#!/bin/sh


kdedir="/opt/kde/share/applnk"

if [ -d "opt/kde/share" ]
then
    kdedir="/opt/kde/share/applnk"
elif [ -d "opt/kde3/share" ]
then
    kdedir="/opt/kde3/share/applnk"
fi

instdir=`pwd`
gnomedir="/usr/share/gnome/apps"

opsystem=`uname -s`
cpoptions="-a -f"

core2=0

if [ -f /etc/redhat-release ]
then
    rhrelease=`cat /etc/redhat-release | grep Tettnang`
    if [ ! -z "$rhrelease" ]
    then
	core2=1
    fi
fi

if [ "$opsystem" = "FreeBSD" ]
then
	gnomedir="/usr/X11R6/share/gnome/apps"
	cpoptions="-p -R -f"
fi

./menupars >/dev/null 2>/dev/null
if [ $? -eq 0 ] ; then
    menupars="./menupars"
else
    ./menupars2 >/dev/null 2>/dev/null
    if [ $? -eq 0 ] ; then
	menupars="./menupars2"
    else
	echo "libxml or libxml2 not found."
	echo "libxml is required for proper desktop folder creation."
	sleep 3
    fi
fi

if [ ! -z "$menupars" ] ; then
    $menupars -c firewall.xml -d >/dev/null 2>/dev/null
fi

mkdir -p /tmp/.fx-kde/desktop
tar -C, --directory /tmp/.fx-kde/desktop -zxf desktop/desktop-gnome2.tar.gz
mkdir -p /tmp/.fx/desktop
tar -C, --directory /tmp/.fx/desktop -zxf desktop/desktop-gnome2.tar.gz
mkdir -p /tmp/.fx-gnome/desktop
tar -C, --directory /tmp/.fx-gnome/desktop -zxf desktop/desktop-gnome2.tar.gz

if [ ! -z "$menupars" ] ; then
    $menupars -c firewall.xml -i >/dev/null 2>/dev/null
    rc=$?
else
    rc=1
fi

if [ $rc -ne 0 ]
then

tar -C, --directory /tmp/.fx-gnome/desktop -zxf desktop/desktop-gnome.tar.gz
tar -C, --directory /tmp/.fx-kde/desktop -zxf desktop/desktop-gnome.tar.gz

for count in 1 2
do
	if [ $count = 1 ]
	then
		if [ $core2 = 1 ]
		then
		    desktop="Desktop"
		else
		    desktop=".gnome-desktop"
		fi
		
		wmdir="$gnomedir"
		cd /tmp/.fx-gnome
		
		mkdir -p "${gnomedir}/Internet/InJoy Firewall/"
		mkdir -p "${gnomedir}/Internet/InJoy Firewall/Information/"
		mkdir -p "${gnomedir}/Internet/InJoy Firewall/Log Files/"
		mkdir -p "${gnomedir}/Internet/InJoy Firewall/Tools/"
		mkdir -p "${gnomedir}/Internet/InJoy Firewall/Packet Tracing/"
		mkdir -p "${gnomedir}/Internet/InJoy Firewall/Extras/"
		
		mkdir -p "${HOME}/${desktop}/InJoy Firewall/"
		mkdir -p "${HOME}/${desktop}/InJoy Firewall/Information/"
		mkdir -p "${HOME}/${desktop}/InJoy Firewall/Log Files/"
		mkdir -p "${HOME}/${desktop}/InJoy Firewall/Tools/"
		mkdir -p "${HOME}/${desktop}/InJoy Firewall/Packet Tracing/"
		mkdir -p "${HOME}/${desktop}/InJoy Firewall/Extras/"
	fi
	if [ $count = 2 ]
	then
		desktop="Desktop"
		wmdir="$kdedir"
		cd /tmp/.fx-kde
		
		mkdir -p "${kdedir}/Internet/InJoy Firewall/"
		mkdir -p "${kdedir}/Internet/InJoy Firewall/Information/"
		mkdir -p "${kdedir}/Internet/InJoy Firewall/Log Files/"
		mkdir -p "${kdedir}/Internet/InJoy Firewall/Tools/"
		mkdir -p "${kdedir}/Internet/InJoy Firewall/Packet Tracing/"
		mkdir -p "${kdedir}/Internet/InJoy Firewall/Extras/"
		
		mkdir -p "${HOME}/Desktop/InJoy Firewall/"
		mkdir -p "${HOME}/Desktop/InJoy Firewall/Information/"
		mkdir -p "${HOME}/Desktop/InJoy Firewall/Log Files/"
		mkdir -p "${HOME}/Desktop/InJoy Firewall/Tools/"
		mkdir -p "${HOME}/Desktop/InJoy Firewall/Packet Tracing/"
		mkdir -p "${HOME}/Desktop/InJoy Firewall/Extras/"
	fi

	    cp ${cpoptions} "desktop/directory" "${wmdir}/Internet/InJoy Firewall/.directory"
	    cat "desktop/InJoy Firewall Server.desktop" | sed s@__INSTALL__@"$instdir"@g > "${wmdir}/Internet/InJoy Firewall/InJoy Firewall Server.desktop"
	    cat "desktop/InJoy Firewall GUI.desktop" | sed s@__INSTALL__@"$instdir"@g > "${wmdir}/Internet/InJoy Firewall/InJoy Firewall GUI.desktop"
	    cat "desktop/Security Logs.desktop" | sed s@__INSTALL__@"$instdir"@g > "${wmdir}/Internet/InJoy Firewall/Security Logs.desktop"
	    cat "desktop/Reload Firewall Configuration.desktop" | sed s@__INSTALL__@"$instdir"@g > "${wmdir}/Internet/InJoy Firewall/Reload Firewall Configuration.desktop"

	    cat "desktop/F_X Communications.desktop" | sed s@__INSTALL__@"$instdir"@g > "${wmdir}/Internet/InJoy Firewall/Information/F_X Communications.desktop"
	    cat "desktop/Firewall Home.desktop" | sed s@__INSTALL__@"$instdir"@g > "${wmdir}/Internet/InJoy Firewall/Information/Firewall Home.desktop"
	    cat "desktop/Firewall Purchase.desktop" | sed s@__INSTALL__@"$instdir"@g > "${wmdir}/Internet/InJoy Firewall/Information/Firewall Purchase.desktop"
	    cat "desktop/Online Documentation.desktop" | sed s@__INSTALL__@"$instdir"@g > "${wmdir}/Internet/InJoy Firewall/Information/Online Documentation.desktop"
    	    cp ${cpoptions} "desktop/directory" "${wmdir}/Internet/InJoy Firewall/Information/.directory"

	    cp ${cpoptions} "desktop/directory" "${wmdir}/Internet/InJoy Firewall/Log Files/.directory"
	    cat "desktop/IPSec Logs.desktop" | sed s@__INSTALL__@"$instdir"@g > "${wmdir}/Internet/InJoy Firewall/Log Files/IPSec Logs.desktop"
	    cat "desktop/DHCPd Logs.desktop" | sed s@__INSTALL__@"$instdir"@g > "${wmdir}/Internet/InJoy Firewall/Log Files/DHCPd Logs.desktop"
	    cat "desktop/PPPoE Logs.desktop" | sed s@__INSTALL__@"$instdir"@g > "${wmdir}/Internet/InJoy Firewall/Log Files/PPPoE Logs.desktop"
	    cat "desktop/PPTP Logs.desktop" | sed s@__INSTALL__@"$instdir"@g > "${wmdir}/Internet/InJoy Firewall/Log Files/PPTP Logs.desktop"

	    cp ${cpoptions} "desktop/directory" "${wmdir}/Internet/InJoy Firewall/Tools/.directory"
	    cat "desktop/Restart Firewall.desktop" | sed s@__INSTALL__@"$instdir"@g > "${wmdir}/Internet/InJoy Firewall/Tools/Restart Firewall.desktop"
	    cat "desktop/Kill Firewall.desktop" | sed s@__INSTALL__@"$instdir"@g > "${wmdir}/Internet/InJoy Firewall/Tools/Kill Firewall.desktop"
	    cat "desktop/Reload IPSec Configuration.desktop" | sed s@__INSTALL__@"$instdir"@g > "${wmdir}/Internet/InJoy Firewall/Tools/Reload IPSec Configuration.desktop"
	    cat "desktop/Reload DHCP Server Configuration.desktop" | sed s@__INSTALL__@"$instdir"@g > "${wmdir}/Internet/InJoy Firewall/Tools/Reload DHCP Server Configuration.desktop"

	    cp ${cpoptions} "desktop/directory" "${wmdir}/Internet/InJoy Firewall/Packet Tracing/.directory"
	    cat "desktop/IP Trace (Start).desktop" | sed s@__INSTALL__@"$instdir"@g > "${wmdir}/Internet/InJoy Firewall/Packet Tracing/IP Trace (Start).desktop"
	    cat "desktop/IP Trace (Stop).desktop" | sed s@__INSTALL__@"$instdir"@g > "${wmdir}/Internet/InJoy Firewall/Packet Tracing/IP Trace (Stop).desktop"
	    cat "desktop/Format Trace (to Screen).desktop" | sed s@__INSTALL__@"$instdir"@g > "${wmdir}/Internet/InJoy Firewall/Packet Tracing/Format Trace (to Screen).desktop"
	    cat "desktop/Delete Trace File.desktop" | sed s@__INSTALL__@"$instdir"@g > "${wmdir}/Internet/InJoy Firewall/Packet Tracing/Delete Trace File.desktop"

	    cp ${cpoptions} "desktop/directory" "${wmdir}/Internet/InJoy Firewall/Extras/.directory"
	    cat "desktop/Admin Remote Firewall.desktop" | sed s@__INSTALL__@"$instdir"@g > "${wmdir}/Internet/InJoy Firewall/Extras/Admin Remote Firewall.desktop"
	    cat "desktop/Run Firewall Server in Background.desktop" | sed s@__INSTALL__@"$instdir"@g > "${wmdir}/Internet/InJoy Firewall/Extras/Run Firewall Server in Background.desktop"
	    cat "desktop/IP Forwarding (Enable).desktop" | sed s@__INSTALL__@"$instdir"@g > "${wmdir}/Internet/InJoy Firewall/Extras/IP Forwarding (Enable).desktop"
	    cat "desktop/IP Forwarding (Disable).desktop" | sed s@__INSTALL__@"$instdir"@g > "${wmdir}/Internet/InJoy Firewall/Extras/IP Forwarding (Disable).desktop"
	    cat "desktop/Change Firewall Adapter.desktop" | sed s@__INSTALL__@"$instdir"@g > "${wmdir}/Internet/InJoy Firewall/Extras/Change Firewall Adapter.desktop"

	cp ${cpoptions} "desktop/directory" "${HOME}/${desktop}/InJoy Firewall/.directory"
	cat "desktop/InJoy Firewall Server.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/${desktop}/InJoy Firewall/InJoy Firewall Server.desktop"
	cat "desktop/InJoy Firewall GUI.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/${desktop}/InJoy Firewall/InJoy Firewall GUI.desktop"
	cat "desktop/Security Logs.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/${desktop}/InJoy Firewall/Security Logs.desktop"
	cat "desktop/Reload Firewall Configuration.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/${desktop}/InJoy Firewall/Reload Firewall Configuration.desktop"

	cat "desktop/F_X Communications.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/${desktop}/InJoy Firewall/Information/F_X Communications.desktop"
	cat "desktop/Firewall Home.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/${desktop}/InJoy Firewall/Information/Firewall Home.desktop"
	cat "desktop/Firewall Purchase.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/${desktop}/InJoy Firewall/Information/Firewall Purchase.desktop"
	cat "desktop/Online Documentation.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/${desktop}/InJoy Firewall/Information/Online Documentation.desktop"
	cp ${cpoptions} "desktop/directory" "${HOME}/${desktop}/InJoy Firewall/Information/.directory"

	cp ${cpoptions} "desktop/directory" "${HOME}/${desktop}/InJoy Firewall/Log Files/.directory"
	cat "desktop/IPSec Logs.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/${desktop}/InJoy Firewall/Log Files/IPSec Logs.desktop"
	cat "desktop/DHCPd Logs.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/${desktop}/InJoy Firewall/Log Files/DHCPd Logs.desktop"
	cat "desktop/PPPoE Logs.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/${desktop}/InJoy Firewall/Log Files/PPPoE Logs.desktop"
	cat "desktop/PPTP Logs.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/${desktop}/InJoy Firewall/Log Files/PPTP Logs.desktop"

	cp ${cpoptions} "desktop/directory" "${HOME}/${desktop}/InJoy Firewall/Tools/.directory"
	cat "desktop/Restart Firewall.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/${desktop}/InJoy Firewall/Tools/Restart Firewall.desktop"
	cat "desktop/Kill Firewall.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/${desktop}/InJoy Firewall/Tools/Kill Firewall.desktop"
	cat "desktop/Reload IPSec Configuration.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/${desktop}/InJoy Firewall/Tools/Reload IPSec Configuration.desktop"
	cat "desktop/Reload DHCP Server Configuration.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/${desktop}/InJoy Firewall/Tools/Reload DHCP Server Configuration.desktop"

	cp ${cpoptions} "desktop/directory" "${HOME}/${desktop}/InJoy Firewall/Packet Tracing/.directory"
	cat "desktop/IP Trace (Start).desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/${desktop}/InJoy Firewall/Packet Tracing/IP Trace (Start).desktop"
	cat "desktop/IP Trace (Stop).desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/${desktop}/InJoy Firewall/Packet Tracing/IP Trace (Stop).desktop"
	cat "desktop/Format Trace (to Screen).desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/${desktop}/InJoy Firewall/Packet Tracing/Format Trace (to Screen).desktop"
	cat "desktop/Delete Trace File.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/${desktop}/InJoy Firewall/Packet Tracing/Delete Trace File.desktop"

	cp ${cpoptions} "desktop/directory" "${HOME}/${desktop}/InJoy Firewall/Extras/.directory"
	cat "desktop/Admin Remote Firewall.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/${desktop}/InJoy Firewall/Extras/Admin Remote Firewall.desktop"
	cat "desktop/Run Firewall Server in Background.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/${desktop}/InJoy Firewall/Extras/Run Firewall Server in Background.desktop"
	cat "desktop/IP Forwarding (Enable).desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/${desktop}/InJoy Firewall/Extras/IP Forwarding (Enable).desktop"
	cat "desktop/IP Forwarding (Disable).desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/${desktop}/InJoy Firewall/Extras/IP Forwarding (Disable).desktop"
	cat "desktop/Change Firewall Adapter.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/${desktop}/InJoy Firewall/Extras/Change Firewall Adapter.desktop"

	done
fi

cd "$instdir"
rm -rf /tmp/.fx-gnome/desktop
rm -rf /tmp/.fx-kde/desktop
rm -rf /tmp/.fx/desktop
mkdir -p /usr/share/pixmaps/
cp ${cpoptions} desktop/*.png /usr/share/pixmaps/
