#!/bin/sh

#################################################
# modified Apr 04, 2006 By Steve Richards
#          for SuSe Linux 10.0 install
#################################################
# Messages definition
#################################################

ABORT="> Aborting installation..."
EXIT="Exiting installation..."

PRESS_Q="Q: Exit installation..."

START_UP="\n\n\n\t\t                YOU ARE ABOUT TO INSTALL 'INJOY FIREWALL 4'\n
          \t\t\t                              ---------------------\n
          \t\t\t                              by  F/X  COMMUNICATIONS "
      

FLOCATE="\n > Kernel source NOT found in /usr/src\n

> To build the Injoy Firewall Driver for the kernel source code\n
> found in /usr/src/redhat/BUILD, please press 'Y' now."

FLOCATE_CHOICE="\n > Kernel source code detected in multiple locations.\n

> Please select the kernel source code that the\n
> Injoy Firewall Driver should be built for:\n
----"

NO_KERN="\n> Your system does NOT have proper Linux kernel source installed\n

> Linux kernel source matching the currently used kernel revision is\n
> required for the Firewall driver module to be installed.\n
> (For more information about how to install kernel sources,\n
> please refer to documentation that came with your Linux distribution)"

NO_KERN_PRECOMPILE=" > To install a pre-compiled driver, Press 'Y' now..."


NO_CRC32="\n > CRC32 kernel module is not enabled now.\n
          > The module may not be neccessary,\n
          > however, if your InJoy Firewall Driver (fx) module does not load,\n
          > please e-mail us at support@fx.dk\n
          \n
          > Continuing with the installation..."

        
ALT_NOT_FOUND="\n > The alternative installation script\n
               > (precompiled.sh) is missing..."


NO_CARDS="\n > You don't appear to have any active network cards..."


LOG_MAIL="\n
          > Please send us copy of the "$instdir"/source/logs content to\n
          > support@fx.dk\n"


CURMOD_NOT_FOUND="\n
                  > You don't have modules folder installed for the currently running kernel.\n
                  > Installation aborted.\n"


INSTALL_TYPE_1="\n
              > You are using kernel `uname -r`, however, the matching\n
              > kernel source does NOT appear to be installed !\n
\n
              > The installation can try to compile the InJoy Firewall driver\n
              > with the available/selected source, or you can try to\n
              > install a pre-compiled driver (if one exists).\n
\n
              1: Compile the InJoy Firewall module with the available kernel source.\n"

INSTALL_TYPE_2="
              2: Try to install a pre-compiled module.\n
              3: Abort installation.\n"

INSTALL_TYPE_2br="
              2: Abort installation.\n"

ASK_TYPE="Type the number of the option you wish to use: "


TIPS_MSG="\n > If you experience problems with your network after the restart,\n
          > please run the Uninstall.sh script.\n"


# kern_menu() messages

WARN_MSG="\t\t\t                           ---------------\n
          \t\t\t                                  ! WARNING !\n
          \t\t\t                           ---------------\n
          \t\t\t                       KERNEL MODULES COMPILED WITH\n
          \t\t\t              NON-COMPATIBLE KERNEL SOURCE CAN POTENTIALLY\n
          \t\t\t                            CAUSE PROBLEMS\n
          \t\t\t                           ---------------\n"
# 3sec pause...

COMPILE_ANYWAY="\n > To compile the module anyway, please select kernel source to use:\n
                ----"
                
# End of kern_menu() msgs        
        

KERN_INFO="\n > You are currently running Linux `uname -r`\n
> Currently, only 2.4.x and 2.6.x kernels supported.
\n
> PLEASE FIRST UNINSTALL ANY PREVIOUSLY INSTALLED INJOY FIREWALL<<\n
\n
If you wish to continue, please type Y and enter now."


# distro_menu() messages

DISTRO_MENU="Select your Linux distribution.\n
            \n
            1:  RedHat 7.2, 7.3, 8.0, 9.0\n
            2:  Slackware 9.1\n
            3:  Mandrake 10\n
            4:  Fedora Core 1, 2, 3, 4, 5, 6; Fedora 7\n
            5:  RedHat Enterprise Linux 3.0, 4.0, 5.0\n
            6:  Debian Sarge\n
            7:  Open SuSE 10.0\n
            ----\n
            Q: Exit installation...\n
            \n
            > Other versions may also work !\n"

ASK_DISTRO="> Type the number of the distribution: "

# DISTRO SELECTION MSGS

RH=" You are about to install InJoy under RedHat 7.2, 7.3, 8.0 or 9.0 linux...\n\n
       Is that correct?  Press 'Y' to continue."

SLACK_91=" You are about to install InJoy under Slackware-9.1 linux...\n\n
           Is that correct? Press 'Y' to continue."

MANDR_10=" You are about to install InJoy under Mandrake-10.0 linux...\n\n
           Is that correct? Press 'Y' to continue."     

FC=" You are about to install InJoy under Fedora Core 1, 2, 3, 4, 5, 6 or Fedora 7 linux...\n\n
           Is that correct? Press 'Y' to continue."

RHEL_30=" You are about to install InJoy under RedHat Enterprise Linux 3.0, 4.0, 5.0..\n\n
           Is that correct? Press 'Y' to continue."

SARGE=" You are about to install InJoy under Debian Sarge linux...\n\n
           Is that correct? Press 'Y' to continue."

SUSE=" You are about to install InJoy under Open SuSE 10.0  LINUX...\n\n
           Is that correct? Press 'Y' to continue."

# End of distro_menu() msg          


# Compiling fx module msg block

COMPILE_FX="> Compiling InJoy driver .... "

COMPILE_SUCCESS="successful !"

COMPILE_FAILED="failed !\n
                \n
                > The driver did not compile successfully!\n
                > Run alternative installation "$instdir" ?\n
                > Press 'Y' to run..."

COMPILE_FAILEDbr="failed !\n
\n
                > The driver did not compile successfully!"

COPY_FX="> Copying the new driver .... "  

COPY_SUCCESS="successful !\n"

COPY_FAILED="failed !\n\n
            > The driver was NOT copied.\n
            \n
            > Please send a copy of the "$instdir"/source/logs content to\n
            > support@fx.dk\n"

MAKE_CHANGE="> Making changes to system files, please wait...\n"


PATCH_FAILED="\n > There was a problem while trying to patch your drivers.\n
              > Please send the content of "$instdir"/source/logs to\n
              > support@fx.dk\n"

BLOCK_ALLOW=" When InJoy Firewall is NOT running, the driver should:\n
             ------\n
             1: Allow all IP traffic (default)\n
             2: Block all IP traffic"

ENABLE_DISABLE=" Gateway features such as Internet Sharing require IP forwarding to be enabled.\n
                ------\n
                1: Enable IP Forwarding\n
                2: Leave setting unmodified (default)"

AUTO_MANUAL=" Firewall Server startup mode:\n
             ------\n
             1: Automatic\n
             2: Manual"

instdir=`pwd`
FINISH="Installation complete, please reboot for changes to take effect.\n
        After rebooting, please run $instdir/Adapter.sh to select interface\n
	that InJoy Firewall will run on.\n"

######## END OF DEFINITIONS #####################


./sync -kill 2>/dev/null >/dev/null

release=`uname -r`
kern_used=linux-"$release"
mod_dir="/lib/modules/`uname -r`/kernel/drivers/net"
opsystem=`uname -s`
cpoptions="-a -f"
target_module=fx

if [ "$1" == "bridge" ] ; then
if [ ! -z `uname -r | grep "2\.6"` ] ; then
        usebridge=$1
        mod_dir="/lib/modules/`uname -r`/kernel/net/bridge/netfilter"
        target_module=bfx
fi
fi

if [ -d /usr/src/kernels ]
then

    cd /usr/src/kernels
    rhel_kern_list=`ls -d *-*-* | cut --delimiter=' ' --fields=1`
    
    for rhel_kernel in $rhel_kern_list
    do
        rhel_kern_ver=`echo $rhel_kernel | cut --delimiter='-' --fields=1`
        rhel_kern_mod=`echo $rhel_kernel | cut --delimiter='-' --fields=2`
        
        rhel_kern_full="linux-$rhel_kern_ver-$rhel_kern_mod"
        
	if [ ! -d /usr/src/$rhel_kern_full ]
	then	
    	    /bin/ln -s /usr/src/kernels/$rhel_kernel /usr/src/$rhel_kern_full
	fi
    done

fi

# Fedora 2.6.x kernel symbols situation

fc_kern_list=`ls /lib/modules`

for fc_kernel in $fc_kern_list
do

    if [ -d /lib/modules/$fc_kernel/build ];
    then
    
	if [ ! -h /lib/modules/$fc_kernel/build ];
	then
	
	    ln -s /lib/modules/$fc_kernel/build /usr/src/linux-$fc_kernel
	
	fi
    
    fi

done

cd /usr/src
kern_list=`ls -d ?inux-2\.* 2>/dev/null | cut --delimiter=' ' --fields=1`

if [ "$opsystem" = "Linux" ]
then
    clear

# Start-up screen
    echo -e $START_UP
    
    sleep 2

clear

function detect_fc_kernels () {

        kern_list="`ls -1 -d ?ed?at/BUILD/?ernel-2\.*/?inux-2\.* | cut --delimiter=' ' --fields=1`"
	
        if [ ! -z "$kern_list" ]
        then
                echo -e $FLOCATE
                read fanswer

                if [ "$fanswer" != Y ]
                then
                        kern_list=""
                else
                        fcnum=`ls -1 -d ?ed?at/BUILD/?ernel-2\.*/?inux-2\.* | cut --delimiter=' ' --fields=1 | wc -l`
                        if [ $fcnum -gt 1 ]
                        then
                                echo -e $FLOCATE_CHOICE
                                fccount=0
                                for flocate in $kern_list
                                do
                                        let fccount="$fccount + 1"
                                        echo "$fccount: `echo $flocate | cut --delimiter='/' --fields=4`"
                                done

                                read fcanswer

                                fccount=0
                                for flocate in $kern_list
                                do
                                        let fccount="$fccount + 1"
                                        if [ "$fccount" = "$fcanswer" ]
                                        then
                                                kern_match=1
                                                kern_dir=/usr/src/$flocate
                                        fi
                                done
                        else
                                kern_match=1
                                kern_dir=/usr/src/$kern_list
                        fi
                fi
        fi

}

# Fedora has weird way to install kernel sources
# making it a bit easier to user
if [ -z "$kern_list" ]
then

    detect_fc_kernels

fi

cd $instdir

kern_match=0

# User choosed Fedora location alread, no need to ask him again
if [ -z "`echo $kern_list | grep BUILD`" ]
then


    # no kernel sources at all
    if [ -z "$kern_list" ]
    then
        clear

        echo -e $NO_KERN

        if [ ! -z $usebridge ] ; then
                exit 1
        fi

        echo -e $NO_KERN_PRECOMPILE
        read alternative
        if [ "$alternative" = Y ]
        then
                cd $instdir
                if [ -f "$instdir"/precompiled.sh ]
                then
                        if [ ! -x "$instdir"/precompiled.sh ]
                        then
                                chmod +x precompiled.sh
                        fi
                        ./precompiled.sh
                        exit 1
                else
                        clear
                        echo -e $ALT_NOT_FOUND
                        exit 1
                fi
        else
                echo $ABORT

                exit 1
        fi

    fi

    # no actualy matched kernel sources
    if [ ! -d /usr/src/?inux-"$release" ]
    then
	if [ ! -z "$kern_list" ]
	then
    	clear

    	    echo -e $INSTALL_TYPE_1

    	    if [ -z $usebridge ] ; then
                echo -e $INSTALL_TYPE_2
    	    else
                echo -e $INSTALL_TYPE_2br
    	    fi

    	    echo -n $ASK_TYPE
    	    read option

    	    case $option in
                1)
                        opt_choice=1
                        ;;
                2)
                        opt_choice=2
                        ;;
                3)
                        opt_choice=3
                        ;;

            esac

            if [ "$opt_choice"  != 1 ]
            then
                if [ "$opt_choice" = 2 ]
                then
                    if [ ! -z $usebridge ] ; then
                        echo $ABORT
                        exit 1
                    fi

                    cd $instdir
                    if [ -f "$instdir"/precompiled.sh ]
                    then
                        if [ ! -x "$instdir"/precompiled.sh ]
                        then
                            chmod +x precompiled.sh
                        fi
                        ./precompiled.sh
                        exit 1
                    else
                        clear
                        echo -e $ALT_NOT_FOUND
                        exit 1
                    fi

                else
                    echo $ABORT
                    exit 1
                fi
            fi

    	    echo -e $TIPS_MSG
    	    sleep 3
    	    clear
	fi
    fi

    ## COUNTS THE NUMBER OF THE INSTALLED KERNEL SOURCES
    kern_num=0
    for list_num in ${kern_list}
    do
	if [ -d /usr/src/"$list_num" ]
	then
	    if [ ! -L /usr/src/"$list_num" ]
	    then
        	let kern_num="$kern_num + 1"
	    fi
	fi
    done
    ## ENDS HERE

    # Check for matching kernel
    
    for match in ${kern_list}
    do
	if [ "`echo $match | cut --delimiter='-' --fields=2-`" = $release ]
	then
    	    kern_match=1
    	    kern_dir=/usr/src/$match
	fi
    done
    # Ends here

# User choosed Fedora location already, no need to ask him again
# Ends here
fi

## MENU APPEAR
## FUNCTION kern_menu
kern_menu () {

    clear
    echo -e $WARN_MSG

    if [ $kern_num -gt 1 ]
    then
        sleep 3
        echo -e $COMPILE_ANYWAY

        list=0
        for file in ${kern_list}
        do
            if [ -d /usr/src/"$file" ]
            then
                if [ ! -L /usr/src/"$file" ]
                then
                    let list="$list + 1"
                    echo ""$list": Use kernel "$file""
                fi
            fi
        done

        echo $PRESS_Q

    ## MENU APPER ENDS HERE

        read kern_answ

    ## USING kern_menu
        if [ $kern_answ = Q ]
        then
            echo $EXIT
            exit 1
        fi

    ## END USING kern_menu
        kern_num1=0
        for list_num1 in ${kern_list}
        do
            if [ -d /usr/src/"$list_num1" ]
            then
                if [ ! -L /usr/src/"$list_num1" ]
                then
                    let kern_num1="$kern_num1 + 1"
                    if [ "$kern_num1" = "$kern_answ" ]
                    then
                        kern_chs="$list_num1"
                    fi
                fi
            fi
        done
    else
        kern_chs=${kern_list}
        echo " > Using installed kernel source \"/usr/src/$kern_chs\""
        sleep 3
    fi

    kern_dir=/usr/src/$kern_chs
}

echo $kern_match

if [ $kern_match -ne 1 ]
then
    kern_menu
fi

## END OF FUCTION kern_menu

# Checking for backup folder
if [ -d /lib/modules/"$release"/kernel/drivers/net/fx-bak ]
then
    bak_check=`ls -R /lib/modules/"$release"/kernel/drivers/net/fx-bak/ |grep "\.backup"`
fi
# End check


if [ ! -d /lib/modules/"$release" ]
then
        echo -e $CURMOD_NOT_FOUND
        sleep 2
        exit 1
fi

echo -e $KERN_INFO

read answer
if [ "$answer" != "Y" ]
then
        echo $ABORT
        exit 1
fi

## FUNCTION distro_menu
pre_distro=""
distro_menu () {
clear

echo -e $DISTRO_MENU

echo -n $ASK_DISTRO

read distro
pre_distro=$distro
#########################################################

case $distro in
                Q)
                        echo $EXIT                
                        exit 1
                        ;;
                1)
                        echo -e $RH                
                        read distro_answer
                        if [ "$distro_answer" = Y ]
                        then
                                distro_choice=RH
                                log_info="RedHat"
                        else
                        echo $ABORT                        
                        exit 1
                        fi
                        ;;
		2)
                        echo -e $SLACK_91                
                        read distro_answer2
                        if [ "$distro_answer2" = Y ]
                        then
                                distro_choice=Slack
                                log_info="Slackware-9.1"
                        else
                        echo $ABORT                        
                        exit 1
                        fi
                        ;;
		3)
                        echo -e $MANDR_10
                        read distro_answer2
                        if [ "$distro_answer2" = Y ]
                        then
                                distro_choice=RH
                                log_info="Mandrake 10"
                        else
                        echo $ABORT                        
                        exit 1
                        fi
                        ;;
                4)
		        echo -e $FC
                        read distro_answer3
                        if [ "$distro_answer3" = Y ]
                        then
                                distro_choice=RH
                                log_info="Fedora Core"
                        else
                        echo $ABORT                        
                        exit 1
                        fi
                        ;;
                5)
                        echo -e $RHEL_30
                        read distro_answer3
                        if [ "$distro_answer3" = Y ]
                        then
                                distro_choice=RH
                                log_info="RedHat Enterprise Linux"
                        else
                        echo $ABORT
                        exit 1
                        fi
                        ;;
                6)
                        echo -e $SARGE
                        read distro_answer3
                        if [ "$distro_answer3" = Y ]
                        then
                                distro_choice=RH
                                log_info="Debian Sarge"
                        else
                        echo $ABORT                        
                        exit 1
                        fi
                        ;;
                7)
                        echo -e $SUSE
                        read distro_answer3
                        if [ "$distro_answer3" = Y ]
                        then
                                distro_choice=SUSE
                                log_info="Open SuSE 10.0"
                        else
                        echo $ABORT                        
                        exit 1
                        fi
                        ;;
                *)
                        distro_menu
                        ;;

esac
}
## END OF FUNCTION distro_menu

distro_menu

                        clear

                        if [ ! -z `uname -r | grep "2\.6"` ]
                        then
                            mod_ext=ko
                        else
                            mod_ext=o
                        fi

                        if [ -f ./fx."$mod_ext" ]
                        then
                                rm -rf fx."$mod_ext"
                        fi

                            cd "$instdir"/source
                            echo -n "$COMPILE_FX "
                            if [ -d "$instdir"/source/logs ]
                            then
                                rm -rf "$instdir"/source/logs
                            fi

                            mkdir "$instdir"/source/logs

                            echo "Before the system changes." >> ./logs/sysinfo.log
                            echo "------------------------" >> ./logs/sysinfo.log
                            echo "Distribution  : "$log_info"" >> ./logs/sysinfo.log
                            echo "Uname info    : `uname -a`" >> ./logs/sysinfo.log
                            echo "Running as     : `whoami`" >> ./logs/sysinfo.log
                            echo "" >> ./logs/sysinfo.log
                            echo "Kern for the compilation: $release" >> ./logs/sysinfo.log
                            echo "Kern source for the compilation: $kern_dir" >> ./logs/sysinfo.log
                            echo "" >> ./logs/sysinfo.log
                            echo "Module list   :" >> ./logs/sysinfo.log
                            echo "`lsmod`" >> ./logs/sysinfo.log
                            echo "------------------------" >> ./logs/sysinfo.log

                            if [ ! -f ./configure ]
                            then
                                   autoconf
                            fi

                            if [ "$mod_ext" = o ]
                            then
                                wmakefile=Makefile-self
                            else
                                wmakefile=Makefile
                            fi

                            if [ ! -z $usebridge ] ; then
                                conf_bridge="--with-bridge"
                            fi

                            ./configure $conf_bridge --with-kerneldir="$kern_dir" >> ./logs/compilation.log 2>> ./logs/compilerrors.log
			    
			    if [ ! -z "`grep "Cannot continue without" logs/compilerrors.log`" ] && [ "$mod_ext" = ko ]
			    then
			    
				# attempt to build with Fedora Core's sources in /usr/src/RedHat/BUILD if our
				# pre-collected 8390.c etc files are missing for this specific kernel
				#
			    
				kern_match=0
				save_kern_dir=$kern_dir
				
				cd /usr/src
				detect_fc_kernels
				cd "$instdir"/source
				
				helper_files_dir=$kern_dir
				kern_dir=$save_kern_dir
				
				if [ kern_match != 0 ] && [ ! -z $helper_files_dir ]
				then
				
                        	    if [ -d "$instdir"/source/logs ]
                        	    then
                            		rm -rf "$instdir"/source/logs
                        	    fi

                        	    mkdir "$instdir"/source/logs
				    
	                            ./configure $conf_bridge --with-kerneldir="$kern_dir" --with-helperfiles=$helper_files_dir >> ./logs/compilation.log 2>> ./logs/compilerrors.log
				
				fi
			    
			    fi
			    
                            make -f $wmakefile clean 2>/dev/null 1>/dev/null

                            make -f $wmakefile >> ./logs/compilation.log 2>> ./logs/compilerrors.log

                            if [ -f ./"$target_module"."$mod_ext" ]
                            then
                                echo -e $COMPILE_SUCCESS
                                compilation_failed=0
                            else
                                if [ ! -z $usebridge ] ; then
                                        echo -e $COMPILE_FAILEDbr
                                        echo $ABORT
                                        exit 1
                                fi

                                echo -e $COMPILE_FAILED
                                compilation_failed=1
                            fi

                        if [ $compilation_failed -eq 1 ] ; then

                        read alternative1
                        if [ "$alternative1" = Y ]
                        then
                                cd $instdir
                                if [ -f "$instdir"/precompiled.sh ]
                                then
                                        if [ ! -x "$instdir"/precompiled.sh ]
                                        then
                                                chmod +x precompiled.sh
                                        fi
                                        ./precompiled.sh $pre_distro
                                        exit 1
                                else
                                        clear
                                        echo -e $ALT_NOT_FOUND
                                        exit 1
                                fi
                        else
                        
                                echo $ABORT
                                echo -e $LOG_MAIL
                                exit 1
                        fi

                        exit 1
                        fi

# Copy the new compiled driver

echo -en "$COPY_FX "

cd "$instdir"/source
cp -a -f ./"$target_module"."$mod_ext" "$mod_dir"

if [ -f "$mod_dir"/"$target_module"."$mod_ext" ]
then

        echo -e $COPY_SUCCESS

else
        echo -e $COPY_FAILED
fi

echo -e $MAKE_CHANGE

if [ -f /etc/fx.conf ]
then
        "$instdir"/Unpatch-Drivers.sh $release

        mv -f /etc/fx.conf /etc/fx.conf.bak
fi

if [ -z $usebridge ]  ; then


# Create a new /etc/fx.conf with the currently loaded
# network drivers.
#
# Take care of 2.6.x behaviour which replaces '-' characters to '_' in module
# names.

/sbin/lsmod | cut --delimiter=' ' --fields=1 > /tmp/modlist.tmp

if [ ! -z `uname -r | grep "2\.6"` ]
then
    /sbin/lsmod | cut --delimiter=' ' --fields=1 | sed s/_/-/g >> /tmp/modlist.tmp
fi

modlist=`sort -u /tmp/modlist.tmp`
rm -f /tmp/modlist.tmp

cd /lib/modules/${release}/kernel/drivers/net/
patchem=`find . ! -type d ! -path "*fx-bak*" -printf "%P\n"`

for file in ${patchem}; do
    shortname=`echo ${file} | cut --delimiter='.' --fields=1`
    for mod in ${modlist}
    do
	if [ "$mod" != "fx" ]
	then
    	    if [ "$mod" == `echo ${shortname} | sed "s@^.*/@@"` ]
    	    then
    		echo "${shortname}#kernel/drivers/net" >> /etc/fx.conf
    	    fi
	fi
    done
done

if [ "$distro_choice" == "SUSE" ]
then

    cd /lib/modules/${release}/extra/
    patchem=`find . ! -type d ! -path "*fx-bak*" -printf "%P\n"`

    for file in ${patchem}; do
	shortname=`echo ${file} | cut --delimiter='.' --fields=1`
	for mod in ${modlist}
	do
	    if [ "$mod" != "fx" ]
	    then
		if [ "$mod" == `echo ${shortname} | sed "s@^.*/@@"` ]
    		then
    		    echo "${shortname}#extra" >> /etc/fx.conf
    		fi
	    fi
	done
    done
    
fi

# madwifi.org drivers
#

if [ -d /lib/modules/${release}/updates ]
then

    cd /lib/modules/${release}/updates/
    patchem=`find . ! -type d ! -path "*fx-bak*" -printf "%P\n"`

    madwifi_modlist="ath_pci ath_hal wlan wlan_acl wlan_ccmp wlan_scan_ap wlan_scan_sta wlan_tkip wlan_wep wlan_xauth"

    for file in ${patchem}; do
	shortname=`echo ${file} | cut --delimiter='.' --fields=1`
	for mod in ${madwifi_modlist}
	do
    	    if [ "$mod" != "fx" ]
    	    then
		if [ "$mod" == `echo ${shortname} | sed "s@^.*/@@"` ]
    		then
    	    	    echo "${shortname}#updates" >> /etc/fx.conf
    		fi
	    fi
	done
    done
    
fi


if [ ! -f /etc/fx.conf ]
then
        echo $NO_CARDS
        echo $ABORT        
        exit 1
fi

# if [ -z $usebridge ]  ; then
fi

echo -n "$target_module" > /etc/fx_target

# copy files needed for patching
#

cd ${instdir}
cp -a -f "$instdir"/sys/fx_objcopy /bin/
cp -a -f "$instdir"/sys/findsym /bin/

# patch drivers
#

if [ -f /etc/fx.conf ]
then
    if [ -z $usebridge ]  ; then
	for file in `cat /etc/fx.conf`
	do
	    fname=`echo $file | cut --delimiter='#' --field=1`
	    path=`echo $file | cut --delimiter='#' --field=2`
	
	    "$instdir"/Patch-Driver.sh $release $fname $path
	done
	    
        echo -e ""
        echo -e "Checking dependendcies ..."
        
        depmod -ae
    fi
fi

# ##############################################################
# Start for RH
# ##############################################################

if [ "$distro_choice" = "RH" ]
then
        cd ${instdir}

        cp -a -f "$instdir"/sys/fx /etc/init.d
        ln -sf /etc/init.d/fx /etc/rc2.d/S10fx
        ln -sf /etc/init.d/fx /etc/rc3.d/S10fx
        ln -sf /etc/init.d/fx /etc/rc4.d/S10fx
        ln -sf /etc/init.d/fx /etc/rc5.d/S10fx

        cp -a -f "$instdir"/sys/gateway /etc/init.d
        ln -sf /etc/init.d/gateway /etc/rc2.d/S90gateway
        ln -sf /etc/init.d/gateway /etc/rc3.d/S90gateway
        ln -sf /etc/init.d/gateway /etc/rc4.d/S90gateway
        ln -sf /etc/init.d/gateway /etc/rc5.d/S90gateway

fi
# ##############################################################
# End for RH
# ##############################################################

# ##############################################################
# Start for SuSe 10.0
# ##############################################################
if [ "$distro_choice" = "SUSE" ]
then
    cd ${instdir}

    cp -a -f "$instdir"/sys/fx.suse /etc/init.d/fx
    /sbin/insserv fx
    
    cp -a -f "$instdir"/sys/gateway.suse /etc/init.d/gateway
    /sbin/insserv gateway

    if [ ! -f /etc/fx_start ];
    then
        echo "${instdir}/gateway" > /etc/fx_start
    fi
   
    echo "gateway: fx network" >> /etc/init.d/.depend.start

fi
# ##############################################################
# End for SUSE
# ##############################################################


# ##############################################################
# Start for Slack
# ##############################################################

if [ "$distro_choice" = "Slack" ]
then

#        crc32load=`/sbin/lsmod | cut --delimiter=' ' --fields=1 |grep crc32`
#        find /etc/rc.d/rc.inet1 -type f -exec gawk '{gsub("eth","fx"); print $0 > FILENAME }' {} \;

        if [ -f /etc/rc.d/rc.fx ]
        then
                rm -f /etc/rc.d/rc.fx
        fi

        cp -a -f "$instdir"/sys/rc.fx /etc/rc.d/

        if [ ! -f /lib/modules/`uname -r`/kernel/lib/crc32.o ]
        then
            echo -e $NO_CRC32                

            echo "There is no crc32.o module compiled" >> "$instdir"/source/logs/sysinfo.log
        fi

        startup_check=`sed '$!d' /etc/rc.d/rc.local`

        if [ "$startup_check" = "/etc/rc.d/rc.fx" ]
        then
            sed '$d' /etc/rc.d/rc.local >/etc/rc.d/rc.local.tmp
            mv -f /etc/rc.d/rc.local.tmp /etc/rc.d/rc.local
        fi

        echo "/etc/rc.d/rc.fx" >> /etc/rc.d/rc.local
        chmod +x /etc/rc.d/rc.local

        cp -a -f ${instdir}/sys/fx.gateway /etc/rc.d/

fi
# ##############################################################
# End of Slack
# ##############################################################



echo -e $BLOCK_ALLOW
read answer

if [ -z $usebridge ] ; then
        submod_dir=/drivers/net
else
        submod_dir=/net/bridge/netfilter
fi


for file in `ls -d /lib/modules/2.*`
do
    if [ -f "$file"/kernel/drivers/net/"$target_module"."$mod_ext" ]
    then
        if [ "$answer" = "2" ]
        then
            mv -f "$file"/kernel"$submod_dir"/"$target_module"."$mod_ext" "$file"/kernel"$submod_dir"/"$target_module".bak
            cat "$file"/kernel"$submod_dir"/"$target_module".bak | sed s@FXENABLED1@FXENABLED0@ > "$file"/kernel"$submod_dir"/"$target_module"."$mod_ext"
        else
            mv -f "$file"/kernel"$submod_dir"/"$target_module"."$mod_ext" "$file"/kernel"$submod_dir"/"$target_module".bak
            cat "$file"/kernel"$submod_dir"/"$target_module".bak | sed s@FXENABLED0@FXENABLED1@ > "$file"/kernel"$submod_dir"/"$target_module"."$mod_ext"
        fi
        rm -f "$file"/kernel"$submod_dir"/"$target_module".bak
    fi
done

fi
cd ${instdir}

# ##############################################################
# End of Linux type
# ##############################################################




# ##############################################################
# Handle FreeBSD specific install
# ##############################################################

if [ "$opsystem" = "FreeBSD" ]
then
        cp ${cpoptions} sys/gateway.sh /usr/local/etc/rc.d/
        if [ ! -e /etc/fx.conf ]
        then
                # Create an /etc/fx.conf from the interface list
                for iface in `/sbin/ifconfig -l`
                do
                        found="0"
                        # Eliminate interfaces that we shouldn't firewall
                        for num in 0 1 2 3 4 5 6 7 8 9
                        do
                                if [ "$iface" = "faith${num}" ]
                                then
                                        found="1"
                                fi
                                if [ "$iface" = "lo${num}" ]
                                then
                                        found="1"
                                fi
                                        if [ "$iface" = "ppp${num}" ]
                                then
                                        found="1"
                                fi
                                if [ "$iface" = "sl${num}" ]
                                then
                                        found="1"
                                fi
                                if [ "$iface" = "tun${num}" ]
                                then
                                        found="1"
                                fi
                                if [ "$iface" = "lp${num}" ]
                                then
                                        found="1"
                                fi
                                if [ "$iface" = "ng${num}" ]
                                then
                                        found="1"
                                fi
                        done
                        # If our iterface is ok add it to fx.conf
                        if [ "$found" = "0" ]
                        then
                                echo "$iface" >> /etc/fx.conf
                        fi
                done

        fi
fi

# ##############################################################
##   bsd ended here
# ##############################################################


if [ ! -e /etc/fx.conf ]
then
        touch /etc/fx.conf
fi


./Folder.sh


cp ${cpoptions} lib/* /usr/lib
/sbin/ldconfig 2> /dev/null

# remove if it exists (reinstall or reconfigure...)
   if [ -f /etc/fx_forward ]
     then
      rm -f /etc/fx_forward
   fi

   clear

   echo -e $ENABLE_DISABLE
    read answer
       
   if [ "$answer" = "1" ]
      then
        echo 1 > /etc/fx_forward
   fi

# remove if it exists (reinstall or reconfigure...)
   if [ -f /etc/fx_start ]
      then
        rm -f /etc/fx_start
   fi

# ##  need to modify for SuSe
# remove if it exists (reinstall or reconfigure...)
   if [ $target_module == "fx" ] ; then
       ./Adapter.sh uninstall
   fi

   clear

# ##############################################################
# ##############################################################

   clear

   echo "${instdir}/gateway" > /etc/fx_start

   echo -e $AUTO_MANUAL
   read answer

# ##############################################################
if [ "$distro_choice" = "SUSE" ]; then
  if [ ! "$answer" = "1" ];
   then
       rm -f /etc/init.d/rc?.d/S90gateway
   fi
 fi
# ##############################################################

   if [ ! "$answer" = "1" ]
   then
       rm -f /etc/rc?.d/S90gateway
   fi

   rm -Rf /tmp/.fx

   clear

   echo -e $FINISH

# ##############################################################
