#!/bin/sh

release=$1
path=$2

if [ -z $release ]
then
    echo -e "Linux kernel version is not specified! Aborting"
    exit
fi

if [ x"$path" == x ]
then
    path="kernel/drivers/net"
fi

if [ ! -z `echo ${release} | grep "2\.6"` ]
then
    mod_ext=ko
else
    mod_ext=o
fi
	
# Checking for backup folder
if [ -d /lib/modules/"$release"/"$path"/fx-bak ]
then
    bak_check=`ls -R /lib/modules/"$release"/"$path"/fx-bak/ |grep "\.backup"`
fi
# End check

# Moving back the original modules
if [ -d /lib/modules/"$release"/"$path"/fx-bak ]
then
    if [ ! -z "$bak_check" ]
    then
	for file in `find /lib/modules/${release}/${path}/fx-bak ! -type d -printf "%P\n"`
	do
	    shortname=`echo ${file} | cut --delimiter='.' --fields=1`
	    cp -af /lib/modules/"$release"/"$path"/fx-bak/"$shortname".backup /lib/modules/"$release"/"$path"/"$shortname"."$mod_ext"
	done

	rm -rf /lib/modules/"$release"/"$path"/fx-bak
    fi
fi
# Ends here

depmod -ae
