#!/bin/sh

cd `/usr/bin/dirname $0`

oper=$1
ifaddr=$2

wrong_params=0
if [ "$oper" != "del" ] ; then
    if [ "$oper" != "add" ] ; then
	wrong_params=1
    fi
fi

if [ -z "$ifaddr" ] ; then
    wrong_params=1
fi

if [ $wrong_params -eq 1 ] ; then
    echo "Enables/Disables global broadcast address 255.255.255.255"
    echo "for specified interface."
    echo "USAGE: $0 <del|add> <interface ip address>"
    exit 1
fi

iflist=`ls /etc/sysconfig/network-scripts/ifcfg-eth*`

# SUSE config location
if [ -z "$iflist" ]
then
    iflist=`ls /etc/sysconfig/network/ifcfg-eth*`
fi


for ifentry in $iflist
do
    DEVICE=""
    IPADDR=""
    LABEL=""
    BRIDGE=""
    FXBRIDGE=""

    . ${ifentry}

    # New style SUSE
    if [ -z "$DEVICE" ] ; then
	if [ ! -z "$LABEL" ] ; then
	    DEVICE=eth"$LABEL"
	fi
    fi

    if [ ! -z "$DEVICE" ]
    then
	# Detect alias in old style system
	if [ ! -z "`echo $DEVICE | grep :`" ] ; then
	    continue
	fi
	# New style SUSE has LABEL_X entries which are filtered itself

	# Check on old-style systems if there device number match the filename
	if [ `basename $ifentry | wc -m` -le 12 ] ; then
	if [ "`basename $ifentry`" != "ifcfg-"$DEVICE ] ; then
	    continue
	fi
	fi

	notbridged=0
	if [ -z $BRIDGE ] ; then
	if [ -z $FXBRIDGE ] ; then
	    notbridged=1
	else
	    BRIDGE=$FXBRIDGE
	fi
	fi

	if [ $notbridged -ne 1 ] ; then
	    DEVICE=""
	    IPADDR=""
	    LABEL=""

	    DEVICE=$BRIDGE
	fi

	res=`/sbin/ip addr show dev $DEVICE 2>/dev/null | grep ${ifaddr}/`

	# Check if address matched
	if [ ! -z "$res" ]
	then
	    /sbin/route $oper -host 255.255.255.255 dev $DEVICE
	    exit 0;
	fi
    fi
done

echo ERROR: No interface matched $ifaddr found!
